﻿using System;
using System.IO;
using System.Xml;
using System.Xml.Serialization;

namespace vJoySteering
{
    [XmlRootAttribute("Config", IsNullable = true)]
    public class Config
    {
        public int Controller;
        public double SteeringGamma;
        public double SteeringLockLimit;
        public double SteeringDeadzone;
        public bool ShowOutput;

        public Config()
        {
            Controller = 1;
            SteeringGamma = 1.0;
            SteeringLockLimit = 1.0;
            SteeringDeadzone = 0.00;
            ShowOutput = true;
        }


        public void Write(string filename)
        {
            var fileWriter = new StreamWriter(filename);

            XmlSerializer serializer = new XmlSerializer(typeof(Config));
            XmlWriterSettings xmlWriterSettings = new XmlWriterSettings() { Indent = true };
            XmlWriter writer = XmlWriter.Create(fileWriter, xmlWriterSettings);
            try
            {
                serializer.Serialize(writer, this);
            }
            catch (Exception)
            {
                fileWriter.Close();
                throw;
            }
            fileWriter.Close();
        }

        public static Config CreateFromFile(string filename)
        {
            Config config = null;
            var serializer = new XmlSerializer(typeof(Config));
            var settings = new XmlWriterSettings() { Indent = true };
            var reader = XmlReader.Create(filename);

            try
            {
                config = (Config)serializer.Deserialize(reader);
            }
            catch (Exception)
            {
                reader.Close();
                throw;
            }
            reader.Close();
            return config;
        }

    }
}
