﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace vJoySteering
{
    class Tools
    {

        public static double Gamma(double value, double gamma)
        {
            return Gamma(value, gamma, 0.0, 1.0);
        }

        public static double Gamma(double value, double gamma, double centerValue, double maxValue)
        {
            double normalizedValue, outputValue;
            normalizedValue = (value - centerValue) / (maxValue - centerValue);
            if (normalizedValue < -0.99)
            {
                normalizedValue = -1.0;
            }
            if (normalizedValue > 0.99)
            {
                normalizedValue = 1.0;
            }

            if (normalizedValue > -0.0001 && normalizedValue < 0.0001)
            {
                outputValue = 0.0;
            }
            else
            {
                if (normalizedValue < 0.0)
                {
                    outputValue = -Math.Pow(-normalizedValue, gamma);
                }
                else
                {
                    outputValue = Math.Pow(normalizedValue, gamma);
                }

                if (outputValue < -0.99)
                {
                    outputValue = -1.0;
                }
                if (outputValue > 0.99)
                {
                    outputValue = 1.0;
                }
            }

            return centerValue + outputValue * (maxValue - centerValue);

        }

        public static double CenterDeadzone(double value, double deadzone)
        {
            return CenterDeadzone(value, deadzone, 0.0, 1.0);
        }

        public static double CenterDeadzone(double value, double deadzone, double centerValue, double maxValue)
        {
            double minValue = centerValue - maxValue;
            double deadzoneValue = (maxValue - centerValue) * deadzone;

            if (value > centerValue - deadzoneValue && value < centerValue + deadzoneValue)
            {
                return centerValue;
            }
            if (value > maxValue - deadzoneValue)
            {
                return maxValue;
            }
            if (value < minValue + deadzoneValue)
            {
                return minValue;
            }

            double deadzoneMultiplier = (maxValue - centerValue) / (maxValue - centerValue - deadzoneValue * 2);
            if (value >= centerValue + deadzoneValue)
            {
                return (value - deadzoneValue) * deadzoneMultiplier;
            }

            if (value <= centerValue - deadzoneValue)
            {
                return (value + deadzoneValue) * deadzoneMultiplier;
            }

            return value;
        }

    }
}
